/*--------------------------------------------------*/

#import "ItsBetaCore.h"

/*--------------------------------------------------*/
#if defined(TARGET_OS_IPHONE)
/*--------------------------------------------------*/

@protocol ItsBetaVkUser;

/*--------------------------------------------------*/

typedef void (^ItsBetaVkSuccessCallback)(NSString* accessToken, NSDate* expirationDate, NSDictionary< ItsBetaVkUser >* user, BOOL isHavePermissions);
typedef void (^ItsBetaVkFailureCallback)(NSError* error);

/*--------------------------------------------------*/

@interface ItsBetaVk : UIViewController< UIWebViewDelegate > {
    BOOL _isHavePermissions;
}

@property (retain, nonatomic) IBOutlet UIWebView* webView;
@property (retain, nonatomic) IBOutlet UIActivityIndicatorView* activityIndicator;

@property (nonatomic, retain) UIViewController* parentController;

@property (nonatomic, retain) NSString* clientId;
@property (nonatomic, retain) NSString* redirectURL;
@property (nonatomic, retain) NSArray* scope;
@property (nonatomic, copy) ItsBetaVkSuccessCallback successCallback;
@property (nonatomic, copy) ItsBetaVkFailureCallback failureCallback;
@property (nonatomic, assign) BOOL animated;

- (void) request;

@end

/*--------------------------------------------------*/
#endif
/*--------------------------------------------------*/
